import torch
#Author: @meetdoshi
class Discriminator(torch.nn.Module):
    '''
    PatchGAN Discriminator with 70x70 overlapping image patches
    '''
    def __init__(self) -> None:
        super().__init__()
        self.model = torch.nn.Sequential(
            torch.nn.Conv2d(3, 64, 4, 2, 1),
            torch.nn.LeakyReLU(0.2, True),
            torch.nn.Conv2d(64, 128, 4, 2, 1),
            torch.nn.InstanceNorm2d(128),
            torch.nn.LeakyReLU(0.2, True),
            torch.nn.Conv2d(128, 256, 4, 2, 1),
            torch.nn.InstanceNorm2d(256),
            torch.nn.LeakyReLU(0.2, True),
            torch.nn.Conv2d(256, 512, 4, 1, 1),
            torch.nn.InstanceNorm2d(512),
            torch.nn.LeakyReLU(0.2, True),
            torch.nn.Conv2d(512, 1, 4, 1, 1),
        )

    def forward(self, x):
        return self.model(x)